These scripts analyze and visualize output generated when one trains Stanford's NER classifier. The three Python scripts may be used to identify any tokens not included in the classifier training data that the trained classifier was able to correctly identify as locations. The R script allows one to visualize TP, FP, FN, P, R, and F1 values as detailed in the report generated by Stanford when one tests a trained classifier. Each script is internally documented, and there are sample data files in this repository that one can use to test the scripts.

Usage:
```bash
# get the list of locations identified by the trained CoreNLP model
python utils/parse-stanford-output.py

# find locations predicted by CoreNLP that weren't in the training data
python utils/find-untrained-locations.py

# validate that the new locations weren't in CoreNLP training data
python utils/validate-new-locations.py
```

To plot the results, you can use `plot/plot.R`.